package atomicstryker.stalkercreepers.common;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.Vec3;

public class EntityAIHelperStalker
{
    public static boolean isSeenByTarget(EntityLiving stalker)
    {
        EntityLivingBase seer = stalker.func_70638_az();
        
        if (stalker == null || seer == null || stalker.func_174813_aQ() == null) return true;
        
        Vec3 visionVec = seer.func_70676_i(1.0F).func_72432_b();
        Vec3 targetVec = new Vec3(stalker.field_70165_t - seer.field_70165_t,
                                            stalker.func_174813_aQ().field_72338_b + (double)(stalker.field_70131_O / 2.0F) - (seer.field_70163_u + (double)seer.func_70047_e()),
                                            stalker.field_70161_v - seer.field_70161_v);
        targetVec = targetVec.func_72432_b();
        double dotProduct = visionVec.func_72430_b(targetVec);
        
        boolean inFOV = dotProduct > 0.1 && seer.func_70685_l(stalker);

        //System.out.println("dotProduct result in isSeenByTarget: "+dotProduct+"; inFOV: "+inFOV);
        
        return inFOV;
    }
}
